
clc
clear
load qs_data.mat
data=snapshot; 
options=[];
% Initial Settings
[n_pts,p]=size(data);
T=T(1:n_pts);


%Maximum parameters values
kmax=15;
Rmax=20;
ki=15;
xerror_max=1e-3;

tic
[Tl,Xl,Rn,kn,xl0,Axl0,fxl0,flag]=Increase_kR(T,data,xerror_max,kmax,Rmax,ki);
disp(strcat('Linearization Time : ',num2str(toc)))
        

% if flag==0
%     plot(Tl,Xl,'.',T,data);
%     title('Linear Model Approximation')
% end
% % Checking Linearization Relative Error
L_error=norm(data-Xl)/norm(data) ;



% Reduction
qmax=51;
qi=29;

% Optimizing the size of the matrices


xerror_max=5e-3;
% Tlr=zeros(size(T,1),1);
% Xlr=zeros(size(data,1),size(data,2));
 
U=zeros(p,qmax,Rmax);
Ar=zeros(qmax,qmax,kmax,Rmax);
Er=zeros(qmax,kmax,Rmax);
Rr=zeros(qmax,kmax,Rmax);

Tlr=[];
Xlr=[];
q=[];
failed=[];
qn=zeros(Rmax,1);
tic
for i=1:size(Rn,1) %for all regions
    
    datar=snapshot(Rn(i,1):Rn(i,2),:);
    xerror=+inf;
    
    q=qi-1;
    
    while (xerror>xerror_max && q<qmax)
        q=q+1;
        k=kn(i);
        x=xl0(:,1:k,i);
        A=Axl0(:,:,1:k,i);
        f=fxl0(:,1:k,i);
        
        [Ue,Are,Ere,Rre]=generate_U(x,A,f,q,k);
        U(:,1:q,i)=Ue;
        Ar(1:q,1:q,1:k,i)=Are;
        Er(1:q,1:k,i)=Ere;
        Rr(1:q,1:k,i)=Rre;
        
        xr0= snapshot(Rn(i,1),:)*Ue;
        [tr,zr]=simulate_model(@Ring_osc_model_l3,T(Rn(i,1):Rn(i,2)),xr0,options,[],...
            Are,Rre,Ere);
        yr=Ue*zr' ;
        xerror= (sum(sum((datar-yr')*(datar-yr')')))/((Rn(i,2)-Rn(i,1))^2);
        
    end
    if (xerror <= xerror_max && q<=qmax)
        
        Tlr(Rn(i,1):Rn(i,2))=tr;
        Xlr(:,Rn(i,1):Rn(i,2))=yr;
        qn(i)=q;
    else
        
        disp(strcat('Region # ',num2str(i),' failed with error= ',num2str(xerror)))
        failed=[failed i];
        
    end
    
    
end
disp(strcat('Model Order Reduction Time : ',num2str(toc)))
 

xerror_max=0.001;
kmax=25;
tff=size(failed,2);
tic
for fi=1:tff
    i=failed(fi);  ki=kn(i)+1;xerror=+inf;
    while (ki<kmax && xerror>xerror_max)
        [rTl,rXl,rRn,rkn,rxl0,rAxl0,rfxl0,rflag]=increase_k(T(Rn(i,1):Rn(i,2)),data(Rn(i,1):Rn(i,2),:),xerror_max,kmax,1,ki);
        plot(rTl,rXl)
        ki=rkn;
        q=qi-1;
        xerror=+inf;
        while (xerror>xerror_max && q<qmax)
            q=q+1;
            k=rkn;
            x=rxl0(:,1:k,1);
            A=rAxl0(:,:,1:k,1);
            f=rfxl0(:,1:k,1);
            
            [Ue,Are,Ere,Rre]=generate_U(x,A,f,q,k);
            U(:,1:q,i)=Ue;
            Ar(1:q,1:q,1:k,i)=Are;
            Er(1:q,1:k,i)=Ere;
            Rr(1:q,1:k,i)=Rre;
            xr0= snapshot(Rn(i,1),:)*Ue;
            [tr,zr]=simulate_model(@Ring_osc_model_l3,T(Rn(i,1):Rn(i,2)),xr0,options,[],...
                Are,Rre,Ere);
            yr=Ue*zr' ;
            xerror= (sum(sum((data(Rn(i,1):Rn(i,2),:)-yr')*(data(Rn(i,1):Rn(i,2),:)-yr')')))/((Rn(i,2)-Rn(i,1))^2);
            
        end
        
        
    end
    if (xerror <= xerror_max && q<=qmax)
        
        disp(strcat('Region # ',num2str(i),' is fixed using k= ',num2str(k), ' clusters'))
        Tlr(Rn(i,1):Rn(i,2))=tr;
        Xlr(:,Rn(i,1):Rn(i,2))=yr;
        qn(i)=q;
        kn(i)=k;
        failed(fi)=[];
        xl0(:,1:k,i)=x;
        Axl0(:,:,1:k,i)=A;
        fxl0(:,1:k,i)=f;
    else
        disp(strcat('Region # ',num2str(i),' failed with error= ',num2str(xerror)))
    end
    
end
disp(strcat('Reduced Model Refinement Time : ',num2str(toc)))

plot(T,data,Tlr,Xlr,'.')
x0=snapshot(1,:);
tic

[T2,D2]=simulate_model(@Ring_osc_model,T ,x0,options);
disp('')
origtime=toc; 
 disp(strcat('Original Model Simulation Time : ',num2str(origtime)))
tic
for i=1:size(Rn,1) %for all regions
    xr0= snapshot(Rn(i,1),:)*U(:,1:qn(i),i);
    [tr,zr]=simulate_model(@Ring_osc_model_l3,T(Rn(i,1):Rn(i,2)),xr0',options,[],...
        Ar(1:qn(i),1:qn(i),1:kn(i),i),Rr(1:qn(i),1:kn(i),i),Er(1:qn(i),1:kn(i),i));
    yr=U(:,1:qn(i),i)*zr' ;
    Tlr2(Rn(i,1):Rn(i,2))=tr;
    Xlr2(:,Rn(i,1):Rn(i,2))=yr;
    
end
Redtime=toc ;
disp(strcat('Reduced Model Simulation Time : ',num2str(Redtime)))
disp(strcat('Speedup = ',num2str(origtime/Redtime)))
close all
Xlr2=Xlr2';
plot(T2,D2,Tlr2,Xlr2,'.')
disp(strcat('State x Relative Error ||x-xr||/||x|| :',num2str(norm(Xlr2-D2)/norm(D2))))
disp(strcat('output y Relative Error ||y-yr||/||y|| :',num2str(norm(Xlr2(:,131)-D2(:,131))/norm(D2(:,131)))))
