function [tpts,pts ] = exp_pts(T,X,alpha)
%  generation of linearization points over one trajectory
%  requires the following functions
%  compute_f : the the full order model ode
%  compute_Jf: the jacobian of the full order model 

[n,p]=size(X);
snapshot=X;
i=1;xi=snapshot(:,1);
pts=xi;tpts=T(1);
error=0;
while i<p
    j=i;
    Axi=compute_Jf(xi);fxi=compute_f(xi);
    while(error<=alpha && j<p)
        j=j+1;
        xj=snapshot(:,j);fxj=compute_f(xj);
        fxjl=fxi+Axi*(xi-xj);
        a=norm(fxjl);
        if(a>0)
        error=norm(fxj-fxjl)/a;
        else
        error=norm(fxj-fxjl);
        end
    end
   if (error>alpha)
    pts=[pts xj];  
    tpts=[tpts T(j)]; 
   end
    error=0;
    size(pts)
    xi=xj;
    i=j;
end
end

             