
function param=paramgen(np)
% generation of gaussian or uniform samples of the parameters vth and kp,
% kn variations
param=zeros(np,4);
wn = 2*180e-9;
ln = 180e-9;
wp = 4*180e-9;
lp = 180e-9;
 
% nominal values
vtn=0.475231;
vtp=-0.449216;
kp=-(wp/lp)*30e-6;
kn=(wn/ln)*90e-6;  
S_Dvtn=(5*1e-3*1e-6)/sqrt(2*wn*ln);
S_Dvtp=(5.49*1e-3*1e-6)/sqrt(2*wp*lp);
S_Dkn=kn*(1.04*1e-6)/sqrt(2*wn*ln)/100;
S_Dkp=kp*(0.99*1e-6)/sqrt(2*wp*lp)/100;

dvtn =paramdist(0,S_Dvtn,np);
dvtp =paramdist(0,S_Dvtp,np);
dkn =paramdist(0,S_Dkn,np);
dkp =paramdist(0,S_Dkp,np);

param(:,1)=dvtn;
param(:,2)=dkn;
param(:,3)=dvtp;
param(:,4)=dkp;
end
